global ProjectName
global AESLPrjWork
global PlatformName
global SynTopModule SynSources
global CycleTime

if { ![info exists ProjectType] } {
	set ProjectType "C/C++"
}

if {[string equal $ProjectType "C/C++"]} {
	if { ![info exists SynTopModule] } {
		puts_err "Top-level module \"SynTopModule\" is not set."
		exit 1
	}
}
if { ![info exists SynSources] } {
	puts_err "Synthesis sources \"SynSources\" are not set."
	exit 1
}

if {![info exists ProjectName]} {
	set ProjectName ""
}

if {![info exists AESLPrjWork]} {
	set AESLPrjWork autowork
}

if { ![info exists TargetInformation] } {
	set TargetInformation ""
}

if { ![info exists PlatformName] } {
	set PlatformName xilinx/virtex4/virtex4
}

if { ![info exists CustomerPlatform] } {
	set CustomerPlatform " "
}

if { ![info exists CycleTime] } {
	set CycleTime 10
}

################################################################
# The main procedures.
################################################################
close_solution
close_project
open_project $ProjectName

if {[string equal $ProjectType "C/C++"]} {
	set_top $SynTopModule
	add_file $SynSources
} else {
	add_file -type sc $SynSources
}

open_solution $AESLPrjWork

auto_import_directive $SynDirectiveFile

create_clock -period $CycleTime
config_io_mode -all auto

append PlatformName ${CustomerPlatform}

foreach ExtraPlatformName ${PlatformName} {
	add_library  $ExtraPlatformName
}

if { ![string equal "" $TargetInformation] } {
	auto_set_target_info $TargetInformation
}

######   PLEASE DO NOT EDIT ABOVE THIS LINE   ###################

######   Insert your constraints / commands here #########



######   PLEASE DO NOT EDIT BELOW THIS LINE   ###################

elaborate
autosyn
close_solution
################################################################
# End of the main procedures.
################################################################
