global coreOperation
set coreOperation ""

proc add_core { a args } {
    global coreOperation
    set bContent "<ipCore corename=\"$a\""
    set argsContent  $args
    for {set i 1} {$i < [llength $argsContent] } {incr i 2} {
           set key [lindex $argsContent [expr $i-1]]
           set key [string range $key 1 end]
           #deal with **-function name which is invalid name in EMF model
           if { [ string equal $key "delay-function"] == 1 } {
              set key "delayfunction"
           } elseif { [ string equal $key "usage-function"] == 1 } {
               set key "usagefunction"
           } elseif { [ string equal $key "latency-function"] == 1 } {
               set key "latencyfunction"
           } 
           set value [lindex $argsContent $i]
           #deal with the resource value which is difficult to be handled by java
           if { [string equal $key "resource"] == 1 } {
              set tmpValue "" 
              for { set j 0 } {$j < [llength $value] } {incr j} {
                  set member  [lindex $value $j]
                  if { [llength $member] == 2 } {
                       append tmpValue " [lindex $member 0]:[lindex $member 1]"
                   } else {
                       append tmpValue " [lindex $member 0]"
                   }
              }
              set value $tmpValue
           }
           append bContent " $key=\"$value\""
           #deal with class conversion problem
           if { [ string equal $key "ports"] == 1 || [string equal $key "cells"] == 1} {
               if { [regexp xsi:type="CoreStorage" $bContent match ] == 0 } {
                   append bContent " xsi:type=\"CoreStorage\""
                }
           } elseif { [string equal $key "depth"] == 1 } {
               if { [regexp xsi:type="CoreConnector" $bContent match ] == 0 } {
                   append bContent " xsi:type=\"CoreConnector\""
                }
           }
           if { [string equal $key "type"] == 1 && [string equal $value "storage"]== 1} {
               if { [regexp xsi:type="CoreStorage" $bContent match ] == 0 } {
                   append bContent " xsi:type=\"CoreStorage\""
                }
           }
           if { [string equal $key "type"] == 1 && [string equal $value "connector"] == 1} {
               if { [regexp xsi:type="CoreConnector" $bContent match ] == 0 } {
                   append bContent " xsi:type=\"CoreConnector\""
                }
           } 
    }
    append bContent " >"
    append bContent " </ipCore>"
    lappend coreOperation "<ipOperation operationtype=\"add_core\">"
    lappend coreOperation $bContent
    lappend coreOperation "</ipOperation>"
}

proc derive_core { a args } {
    global coreOperation
    set bContent "<ipCore corename=\"$a\""
    set argsContent  $args
    for {set i 1} {$i < [llength $argsContent] } {incr i 2} {
           set key [lindex $argsContent [expr $i-1]]
           set key [string range $key 1 end]
           #deal with **-function name which is invalid name in EMF model
	   if { [ string equal $key "delay-function"] == 1 } {
              set key "delayfunction"
           } elseif { [ string equal $key "usage-function"] == 1 } {
               set key "usagefunction"
           } elseif { [ string equal $key "latency-function"] == 1 } {
               set key "latencyfunction"
           }
           set value [lindex $argsContent $i]
           #deal with the resource value which is difficult to be handled by java
           if { [string equal $key "resource"] == 1 } {
              set tmpValue "" 
              for { set j 0 } {$j < [llength $value] } {incr j} {
                  set member  [lindex $value $j]
                  if { [llength $member] == 2 } {
                       append tmpValue " [lindex $member 0]:[lindex $member 1]"
                   } else {
                       append tmpValue " [lindex $member 0]"
                   }
              }
              set value $tmpValue
           }
           append bContent " $key=\"$value\""
           #deal with class conversion problem
           if { [ string equal $key "ports"] == 1 || [string equal $key "cells"] == 1} {
               if { [regexp xsi:type="CoreStorage" $bContent match ] == 0 } {
                   append bContent " xsi:type=\"CoreStorage\""
                }
           } elseif { [string equal $key "depth"] == 1 } {
               if { [regexp xsi:type="CoreConnector" $bContent match ] == 0 } {
                   append bContent " xsi:type=\"CoreConnector\""
                }
           }
           if { [string equal $key "type"] == 1 && [string equal $value "storage"]== 1} {
               if { [regexp xsi:type="CoreStorage" $bContent match ] == 0 } {
                   append bContent " xsi:type=\"CoreStorage\""
                }
           }
           if { [string equal $key "type"] == 1 && [string equal $value "connector"] == 1} {
               if { [regexp xsi:type="CoreConnector" $bContent match ] == 0 } {
                   append bContent " xsi:type=\"CoreConnector\""
                }
           } 
    }
    append bContent " >"
    append bContent " </ipCore>"
    lappend coreOperation "<ipOperation operationtype=\"derive_core\">"
    lappend coreOperation $bContent
    lappend coreOperation "</ipOperation>"
}

proc config_core { a args } {
    global coreOperation
    set bContent "<ipCore corename=\"$a\""
    set argsContent  $args
    for {set i 1} {$i < [llength $argsContent] } {incr i 2} {
           set key [lindex $argsContent [expr $i-1]]
           set key [string range $key 1 end]
           #deal with **-function name which is invalid name in EMF model
           if { [ string equal $key "delay-function"] == 1 } {
              set key "delayfunction"
           } elseif { [ string equal $key "usage-function"] == 1 } {
               set key "usagefunction"
           } elseif { [ string equal $key "latency-function"] == 1 } {
               set key "latencyfunction"
           }
           set value [lindex $argsContent $i]
           #deal with the resource value which is difficult to be handled by java
           if { [string equal $key "resource"] == 1 } {
              set tmpValue "" 
              for { set j 0 } {$j < [llength $value] } {incr j} {
                  set member  [lindex $value $j]
                  if { [llength $member] == 2 } {
                       append tmpValue " [lindex $member 0]:[lindex $member 1]"
                   } else {
                       append tmpValue " [lindex $member 0]"
                   }
              }
              set value $tmpValue
           }
           append bContent " $key=\"$value\""
           #deal with class conversion problem
           if { [ string equal $key "ports"] == 1 || [string equal $key "cells"] == 1} {
               if { [regexp xsi:type="CoreStorage" $bContent match ] == 0 } {
                   append bContent " xsi:type=\"CoreStorage\""
                }
           } elseif { [string equal $key "depth"] == 1 } {
               if { [regexp xsi:type="CoreConnector" $bContent match ] == 0 } {
                   append bContent " xsi:type=\"CoreConnector\""
                }
           }
           if { [string equal $key "type"] == 1 && [string equal $value "storage"]== 1} {
               if { [regexp xsi:type="CoreStorage" $bContent match ] == 0 } {
                   append bContent " xsi:type=\"CoreStorage\""
                }
           }
           if { [string equal $key "type"] == 1 && [string equal $value "connector"] == 1} {
               if { [regexp xsi:type="CoreConnector" $bContent match ] == 0 } {
                   append bContent " xsi:type=\"CoreConnector\""
                }
           } 
     }
    append bContent " >"
    append bContent " </ipCore>"
    lappend coreOperation "<ipOperation operationtype=\"config_core\">"
    lappend coreOperation $bContent
    lappend coreOperation "</ipOperation>"
}

proc dump_lib { } {
    global coreOperation
    set file [file join libraryEditorContent.xml]
    set outfile [open $file w]
    puts $outfile "<?xml version=\"1.0\" encoding=\"UTF-8\"?>"
    puts $outfile "<IPCoreOperations xmlns=\"www.autoesl.com/libraryEditor\">"
    for {set i 0} {$i < [llength $coreOperation] } {incr i } {
        puts $outfile [lindex $coreOperation $i]
     }
    puts $outfile "</IPCoreOperations>"
    close $outfile
}

if { $argc != 1 } {
        puts "Only one parameter (The absolute path or relative path to the project) is allowed."
        puts "Please try again."
} else {
       source [lindex $argv 0]
       dump_lib
       }
